#!/usr/local/bin/perl -w

# $Header: /nfs/pathsoft/repository/psu/genexec/perl/src/embl_note_joiner.pl,v 1.3 1999/03/17 10:41:21 kmr Exp $

# purpose: This script will read a diana .tab file (EMBL feature table) and
# purpose: change all multi-line qualifiers to one-line qualifiers

use strict;

if (@ARGV == 0 || $ARGV[0] =~ /^-/) {
  die <<EOF;
usage: $0 filename [filename ...]
  the output is written to filename.new
EOF
}

for my $file_name (@ARGV) {
  open (FILE, "$file_name") || 
    die "can't open $file_name for reading\n";
  open (OUT, ">$file_name.new") || 
    die "can't open $file_name.new for writing\n";

  my @lines = <FILE>;

  my $i = 0;

  while ($i < @lines) {

    if ($lines[$i] =~ m!FT                    */(\w+)=(.*)! ) {
      my $name = $1;
      my $value = $2;
      ++$i;

      while ($i < @lines && 
             $lines[$i] =~ m!FT                   ( *[^ /\n].*)!) {
        $value .= $1;
        ++$i;
      }

      print OUT "FT                   /$name=$value\n";
    } else {
      print OUT $lines[$i];
      ++$i;
    }
  }
  
  close FILE;
  close OUT;
}
