#!/usr/local/bin/perl -w

# Author: kdj@sanger.ac.uk

use strict;

while (<>)
{
    if (/^>(\S+)\s+(\d+)\s+(\d+)\s+(\d+)\s+(\S+)\s+(.*)/)
    {
	my ($id, $start, $end, $dps, $codon, $desc) = ($1, $2, $3, $4, $5, $6);
	$desc = ucfirst($desc);
	$desc =~ s/\s+$//;

	my $location;
	if ($start < $end)
	{
	    $location = ($start + 1) . ".." . ($end + 1);
	}
	else
	{
	    $location = "complement(" . ($end + 1) . ".." . ($start + 1) . ")";
	}

	print "FT   CDS             $location\n";
	print "FT                   /note=\"$desc. Coding potential quality = $codon\"\n";
	print "FT                   /label=$id\n";
	print "FT                   /colour=3\n";
    }
}
