#!/usr/local/bin/perl -w

# $Header: /nfs/pathsoft/repository/psu/genexec/perl/src/roll_file.pl,v 1.1 1999/09/28 12:16:58 kmr Exp $

# purpose: This script will create numbered backups of a given file

use strict;

use File::Copy;

sub usage
{
  die <<EOF;
usage $0 file_name
   or $0 file_name <max_backups>

<max_backups> should be the maximum number of backups to make (default 10)
EOF
}

if (@ARGV < 1 || @ARGV > 2) {
  usage ();
}

my $file_to_backup = $ARGV[0];

my $max_backups = 10;

if (@ARGV == 2) {
  $max_backups = $ARGV[1];
}

copy ($file_to_backup, "$file_to_backup.backup") or
  die "$0: can't open $file_to_backup.backup\n";

# rename
opendir DIR, "."; 

my @files = grep {/^$file_to_backup\.backup\.\d+$/} readdir DIR;

# print "@files\n";

foreach my $file (sort {
  my ($a1,$a2) = $a =~ /^$file_to_backup\.backup\.(\d+)$/;
  my ($b1,$b2) = $b =~ /^$file_to_backup\.backup\.(\d+)$/;

  my $t = $b1 cmp $a1;

  if ( $t != 0 ) {
    $t;
  } else {
    $b2 <=> $a2;
  }
} @files) {

  $file =~ /^$file_to_backup\.backup\.(\d+)$/;

  my $new_ext = $1;
      
  $new_ext++;               # 001 -> 002;

  my  $new_file  = "$file_to_backup.backup.$new_ext";
      
  if ($new_ext <= $max_backups) {
    rename "$file", "$new_file";
  }

  # print "renaming $file to $new_file\n";
}

rename "$file_to_backup.backup", "$file_to_backup.backup.001";

